aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorWilliam Harrington <kb0iic@berzerkula.org>2021-04-02 11:33:59 -0500
committerWilliam Harrington <kb0iic@berzerkula.org>2021-04-02 11:33:59 -0500
commit09a71c051060d3b934a19ae4d9c962f7ceb44c69 (patch)
tree12b46d0b4caf7a21d9a37dc8d0de6442c929fe33
parentf063af2cf37ddb9e542e8b085f350f79802e87e8 (diff)
parente2547734fd91c35bf3eaac1d9486b0f3c2877192 (diff)
Merge branch 'cleanup' into chapter7
-rw-r--r--download.sh2
-rw-r--r--env.sh2
-rw-r--r--functions.sh4
-rw-r--r--insidechroot.sh6
-rwxr-xr-xlfs.sh28
-rw-r--r--mountvirtfs.sh2
-rw-r--r--packageinstall.sh6
-rw-r--r--preparechroot.sh6
-rw-r--r--setupdisk.sh5
-rwxr-xr-xversioncheck.sh10
10 files changed, 42 insertions, 29 deletions
diff --git a/download.sh b/download.sh
index d210b1e..af1dd08 100644
--- a/download.sh
+++ b/download.sh
@@ -9,7 +9,7 @@ cat packages.csv patches.csv | while read -r line; do
MD5SUM="$(echo "$line" | cut -d\, -f4)"
CACHEFILE="$(basename "${URL}")"
- if [ ! -f "${CACHEFILE}" ]; then
+ if [[ ! -f "${CACHEFILE}" ]]; then
printf "%b" "${PRP}Downloading ${YLW}${CACHEFILE}${RST}... "
diff --git a/env.sh b/env.sh
index 7a690e4..5e11081 100644
--- a/env.sh
+++ b/env.sh
@@ -10,7 +10,7 @@ LFS="/mnt/lfs"
LC_ALL="POSIX"
LFS_TGT="$(uname -m)"-lfs-linux-gnu
PATH=/usr/bin
-if [ ! -L /bin ]; then PATH="/bin:${PATH}"; fi
+if [[ ! -L /bin ]]; then PATH="/bin:${PATH}"; fi
PATH="${LFS}/tools/bin:${PATH}"
CONFIG_SITE="${LFS}/usr/share/config.site"
# End book environment settings
diff --git a/functions.sh b/functions.sh
index 63fa887..a260f66 100644
--- a/functions.sh
+++ b/functions.sh
@@ -8,7 +8,7 @@ download()
wget -nc -q --show-progress --progress=dot "$url" 2>&1 | grep --line-buffered "%" | \
sed -u -e "s,\.,,g" | awk '{printf("\b\b\b\b%4s", $2)}'
local retval="${PIPESTATUS[0]}"
- if [ "${retval}" -ne 0 ]; then
+ if [[ "${retval}" -ne 0 ]]; then
printf "%b" "${RED}FAILED! WGET EXIT (${retval})\n${RST}"
exit "${retval}"
fi
@@ -41,7 +41,7 @@ function spinner() {
local spintype=$2
- if [ -z "${spintype}" ] || [ "${spintype}" -ge "${numspinners}" ]; then
+ if [[ -z "${spintype}" ]] || [[ "${spintype}" -ge "${numspinners}" ]]; then
spintype=$((RANDOM % numspinners))
fi
diff --git a/insidechroot.sh b/insidechroot.sh
index 307e990..d943214 100644
--- a/insidechroot.sh
+++ b/insidechroot.sh
@@ -7,9 +7,9 @@ source /sources/functions.sh
printf "%b" "${CYN}SUCCESSFULLY ENTERED ${RED}CHROOT${RST}!\n"
-if [ "${CHAPTER}" -eq 7 ]; then
+if [[ "${CHAPTER}" -eq 7 ]]; then
printf "%b" "${GRN}Creating directories...${RST}\n"
- if [ -f /sources/createdirs ]; then
+ if [[ -f /sources/createdirs ]]; then
printf "%b" "${IGRN} Directories already created.${RST}\n"
else
mkdir -p /boot
@@ -88,7 +88,7 @@ if [ "${CHAPTER}" -eq 7 ]; then
fi
printf "%b" "${GRN}Creating essential files and symbolic links... ${RST}\n"
- if [ -f "/sources/essential" ]; then
+ if [[ -f "/sources/essential" ]]; then
printf "%b" " ${IGRN}Essential files and symbolic links already created.${RST}\n"
else
ln -sf /proc/self/mounts /etc/mtab
diff --git a/lfs.sh b/lfs.sh
index 39b515a..873426c 100755
--- a/lfs.sh
+++ b/lfs.sh
@@ -33,7 +33,7 @@ before continuing.${RST}\n\n\n"
# Continue or Abort
printf "%b" "${IGRN}CONTINUE ${IWHTB}(C)${RST} / ${IRED}ABORT ${IWHTB}(OTHER)${RST}\n"
if read -r -n 1 contabort; then
- if [ "$contabort" == "C" ] || [ "$contabort" == "c" ]; then
+ if [[ "$contabort" == "C" ]] || [[ "$contabort" == "c" ]]; then
printf "%b" "\b${IWHT}Build is ${IGRN}CONTINUING${RST}\n\n"
else
printf "%b" "\b${IWHT}Build ${IRED}ABORTED!\n\n"
@@ -44,9 +44,16 @@ else
exit 1
fi
-printf "%b" "${GRN}Creating LFS directory at ${YLW}${LFS}${GRN} if it does not exist...${RST}\n"
# Create LFS directory if it doesn't exist
-[[ -d /mnt/lfs ]] || sudo mkdir "${LFS}"
+printf "%b" "${GRN}Creating LFS directory at ${YLW}${LFS}${GRN}... ${RST}"
+if [[ -d "${LFS}" ]]; then
+ printf "%b" "${IGRN}EXISTS${RST}\n"
+else
+ if ! mkdir "${LFS}" >/dev/null 2>&1; then
+ printf "%b" "${IRED}FAILED!${RST}\n"
+ exit 1
+ fi
+fi
# Setup partition, filesystem, format and mount if
# LFS filesystem is not previously mounted
@@ -84,9 +91,14 @@ esac
# Copy scripts and csv files to LFS sources target
printf "%b" "${GRN}Copying required files to ${YLW}${LFS}/sources \
-${GRN}target directory...${RST}\n"
+${GRN}target directory... ${RST}"
+
+if ! cp -rf ./*.sh chapter* ./*.csv "${LFS}/sources"; then
+ printf "%b" "${IRED}FAILED!${RST}\n"
+else
+ printf "%b" "${GRN}OK${RST}\n"
+fi
-cp -rf ./*.sh chapter* ./*.csv "${LFS}/sources"
cd "${LFS}/sources" || exit 1
# Download packages and patches
@@ -94,7 +106,7 @@ printf "%b" "\n${IWHT}============ ${IGRN}Downloading source files and patches \
${IWHT}============${RST}\n"
source download.sh
retval=$?
-if [ "$retval" -ne 0 ]; then
+if [[ "$retval" -ne 0 ]]; then
exit 1
fi
@@ -104,7 +116,7 @@ printf "%b" "\n${IWHT}============ ${IGRN}Building ${IYLW}Chapter 5${IWHT} \
for package in binutils gcc linux-api-headers glibc libstdc++; do
source packageinstall.sh 5 $package
retval=$?
- if [ "$retval" -ne 0 ]; then
+ if [[ "$retval" -ne 0 ]]; then
exit 1
fi
done
@@ -115,7 +127,7 @@ printf "%b" "\n${IWHT}============ ${IGRN}Building ${IYLW}Chapter 6${IWHT} \
for package in m4 ncurses bash coreutils diffutils file findutils gawk grep gzip make patch sed tar xz binutils gcc; do
source packageinstall.sh 6 $package
retval=$?
- if [ "$retval" -ne 0 ]; then
+ if [[ "$retval" -ne 0 ]]; then
exit 1
fi
done
diff --git a/mountvirtfs.sh b/mountvirtfs.sh
index 2849dad..4c016e5 100644
--- a/mountvirtfs.sh
+++ b/mountvirtfs.sh
@@ -27,6 +27,6 @@ else
printf "%b" " ${IYLW}${LFS}/run${IGRN} is already mounted${RST}\n"
fi
-if [ -h "${LFS}"/dev/shm ]; then
+if [[ -h "${LFS}"/dev/shm ]]; then
sudo mkdir -pv "${LFS}"/"$(readlink "${LFS}"/dev/shm)"
fi
diff --git a/packageinstall.sh b/packageinstall.sh
index afd11a0..43fd4eb 100644
--- a/packageinstall.sh
+++ b/packageinstall.sh
@@ -3,7 +3,7 @@
CHAPTER="$1"
PACKAGE="$2"
-if [ -f "${LFS}/sources/chapter${CHAPTER}/${PACKAGE}" ]; then
+if [[ -f "${LFS}/sources/chapter${CHAPTER}/${PACKAGE}" ]]; then
printf "%b" "${GRN}Package ${YLW}${PACKAGE} ${GRN}already built and installed for ${YLW}Chapter ${CHAPTER}.${RST}\n"
else
@@ -20,7 +20,7 @@ else
tar xf "${CACHEFILE}" > /dev/null 2>&1 & pid=$!
spinner "$pid" "${SPINNER}"
retval=$?
- if [ "$retval" -ne 0 ]; then
+ if [[ "$retval" -ne 0 ]]; then
printf "%b" "${GRN}Extraction ${RED}FAILED!${RST}\n"
return $retval
else
@@ -35,7 +35,7 @@ else
source "${LFS}/sources/chapter${CHAPTER}/${PACKAGE}.sh" 2>&1 > "${LFS}/sources/log/chapter${CHAPTER}/${PACKAGE}.log" 2>&1 & pid=$!
spinner "$pid" "${SPINNER}"
retval=$?
- if [ "$retval" -ne 0 ]; then
+ if [[ "$retval" -ne 0 ]]; then
printf "%b" "${RED}FAILED!${RST}\n"
popd > /dev/null || return 1
return $retval
diff --git a/preparechroot.sh b/preparechroot.sh
index 32f6558..82cd147 100644
--- a/preparechroot.sh
+++ b/preparechroot.sh
@@ -4,17 +4,17 @@ source colors.sh
export LFS="$1"
-if [ -f chrootprepared ]; then
+if [[ -f chrootprepared ]]; then
printf "%b" " ${IRED}CHROOT ${IGRN}already prepared...\n${RST}"
exit 0
fi
-if [ -z "${LFS}" ]; then
+if [[ -z "${LFS}" ]]; then
printf "%b" "${RED}Require first argument as path to LFS build!${RST}\n"
exit 1
fi
-if [ "${USER}" == "root" ]; then
+if [[ "${USER}" == "root" ]]; then
printf "%b" "${GRN}Changing ownership to root...${RST}\n"
chown -R root:root "${LFS}"/bin
chown -R root:root "${LFS}"/etc
diff --git a/setupdisk.sh b/setupdisk.sh
index 6d13436..b79f27f 100644
--- a/setupdisk.sh
+++ b/setupdisk.sh
@@ -20,14 +20,15 @@ p
w
q
EOF
-if [[ "$?" -ne 0 ]]; then
+retval=$?
+if [[ "$retval" -ne 0 ]]; then
printf "%b" " ${IGRN}Creating partition ${IWHT}${LFS_DISK}${LFS_PART} \
${IRED}FAILED!${RST}\n"
exit 1
fi
printf "%b" " ${IGRN}Formatting ${IWHT}${LFS_DISK}${LFS_PART} with \
${IWHT}${LFS_FS}${IGRN} filesystem and label ${IWHT}${LFS_VER}${RST}\n"
-if ! sudo /sbin/mkfs -t ${LFS_FS,,} -L "${LFS_VER}" -F "${LFS_DISK}${LFS_PART}" >/dev/null 2>&1; then
+if ! sudo /sbin/mkfs -t "${LFS_FS,,}" -L "${LFS_VER}" -F "${LFS_DISK}${LFS_PART}" >/dev/null 2>&1; then
printf "%b" " ${IGRN}Creating ${IWHT}${LFS_FS}${IGRN} filesystem at \
${IWHT}${LFS_DISK}${LFS_PART} ${IRED}FAILED!${RST}\n"
exit 1
diff --git a/versioncheck.sh b/versioncheck.sh
index 27c113b..3b83d81 100755
--- a/versioncheck.sh
+++ b/versioncheck.sh
@@ -12,9 +12,9 @@ echo -n "Binutils: "
ld --version | head -n1 | cut -d" " -f3-
bison --version | head -n1
-if [ -h /usr/bin/yacc ]; then
+if [[ -h /usr/bin/yacc ]]; then
echo "/usr/bin/yacc -> $(readlink -f /usr/bin/yacc)"
-elif [ -x /usr/bin/yacc ]; then
+elif [[ -x /usr/bin/yacc ]]; then
echo yacc is "$(/usr/bin/yacc --version | head -n1)"
else
echo "yacc not found"
@@ -27,9 +27,9 @@ diff --version | head -n1
find --version | head -n1
gawk --version | head -n1
-if [ -h /usr/bin/awk ]; then
+if [[ -h /usr/bin/awk ]]; then
echo "/usr/bin/awk -> $(readlink -f /usr/bin/awk)"
-elif [ -x /usr/bin/awk ]; then
+elif [[ -x /usr/bin/awk ]]; then
echo awk is "$(/usr/bin/awk --version | head -n1)"
else
echo "awk not found"
@@ -52,7 +52,7 @@ makeinfo --version | head -n1 # texinfo version
xz --version | head -n1
echo 'int main(){}' >dummy.c && g++ -o dummy dummy.c
-if [ -x dummy ]; then
+if [[ -x dummy ]]; then
echo "g++ compilation OK"
else echo "g++ compilation failed"; fi
rm -f dummy.c dummy